diff --git a/app/test-pmd/cmdline.c b/app/test-pmd/cmdline.c
index 7ab0575e64..163e9c3fc9 100644
--- a/app/test-pmd/cmdline.c
+++ b/app/test-pmd/cmdline.c
@@ -17974,6 +17974,7 @@ cmdline_parse_ctx_t main_ctx[] = {
 	(cmdline_parse_inst_t *)&cmd_del_port_meter_policy,
 	(cmdline_parse_inst_t *)&cmd_set_port_meter_profile,
 	(cmdline_parse_inst_t *)&cmd_set_port_meter_dscp_table,
+	(cmdline_parse_inst_t *)&cmd_set_port_meter_vlan_table,
 	(cmdline_parse_inst_t *)&cmd_set_port_meter_stats_mask,
 	(cmdline_parse_inst_t *)&cmd_show_port_meter_stats,
 	(cmdline_parse_inst_t *)&cmd_mcast_addr,
diff --git a/app/test-pmd/cmdline_mtr.c b/app/test-pmd/cmdline_mtr.c
index ad7ef6ad98..7532d454ae 100644
--- a/app/test-pmd/cmdline_mtr.c
+++ b/app/test-pmd/cmdline_mtr.c
@@ -14,6 +14,7 @@
 #include "cmdline_mtr.h"
 
 #define PARSE_DELIMITER				" \f\n\r\t\v"
+#define MAX_VLAN_TABLE_ENTRIES		16
 #define MAX_DSCP_TABLE_ENTRIES		64
 
 /** Display Meter Error Message */
@@ -82,6 +83,125 @@ parse_uint(uint64_t *value, const char *str)
 	return 0;
 }
 
+static int
+parse_input_color_table_entries(char *str, enum rte_color **dscp_table,
+	enum rte_color **vlan_table)
+{
+	enum rte_color *vlan, *dscp;
+	char *token;
+	int i = 0;
+
+	token = strtok_r(str, PARSE_DELIMITER, &str);
+	if (token == NULL)
+		return 0;
+
+	/* Allocate memory for dscp table */
+	dscp = (enum rte_color *)malloc(MAX_DSCP_TABLE_ENTRIES *
+		sizeof(enum rte_color));
+	if (dscp == NULL)
+		return -1;
+
+	while (1) {
+		if (strcmp(token, "G") == 0 || strcmp(token, "g") == 0)
+			dscp[i++] = RTE_COLOR_GREEN;
+		else if (strcmp(token, "Y") == 0 || strcmp(token, "y") == 0)
+			dscp[i++] = RTE_COLOR_YELLOW;
+		else if (strcmp(token, "R") == 0 || strcmp(token, "r") == 0)
+			dscp[i++] = RTE_COLOR_RED;
+		else {
+			free(dscp);
+			return -1;
+		}
+		if (i == MAX_DSCP_TABLE_ENTRIES)
+			break;
+
+		token = strtok_r(str, PARSE_DELIMITER, &str);
+		if (token == NULL) {
+			free(dscp);
+			return -1;
+		}
+	}
+
+	*dscp_table = dscp;
+
+	token = strtok_r(str, PARSE_DELIMITER, &str);
+	if (token == NULL)
+		return 0;
+
+	/* Allocate memory for vlan tables */
+	vlan = (enum rte_color *)malloc(MAX_VLAN_TABLE_ENTRIES *
+		sizeof(enum rte_color));
+	if (vlan == NULL)
+		return -1;
+
+	i = 0;
+	while (1) {
+		if (strcmp(token, "G") == 0 || strcmp(token, "g") == 0)
+			vlan[i++] = RTE_COLOR_GREEN;
+		else if (strcmp(token, "Y") == 0 || strcmp(token, "y") == 0)
+			vlan[i++] = RTE_COLOR_YELLOW;
+		else if (strcmp(token, "R") == 0 || strcmp(token, "r") == 0)
+			vlan[i++] = RTE_COLOR_RED;
+		else {
+			free(vlan);
+			return -1;
+		}
+		if (i == MAX_VLAN_TABLE_ENTRIES)
+			break;
+
+		token = strtok_r(str, PARSE_DELIMITER, &str);
+		if (token == NULL) {
+			free(vlan);
+			return -1;
+		}
+	}
+
+	*vlan_table = vlan;
+	return 0;
+}
+
+static int
+parse_vlan_table_entries(char *str, enum rte_color **vlan_table)
+{
+	char *token;
+	int i = 0;
+
+	token = strtok_r(str, PARSE_DELIMITER, &str);
+	if (token == NULL)
+		return 0;
+
+	/* Allocate memory for vlan table */
+	*vlan_table = (enum rte_color *)malloc(MAX_VLAN_TABLE_ENTRIES *
+		sizeof(enum rte_color));
+	if (*vlan_table == NULL)
+		return -1;
+
+	while (1) {
+		if (strcmp(token, "G") == 0 ||
+			strcmp(token, "g") == 0)
+			(*vlan_table)[i++] = RTE_COLOR_GREEN;
+		else if (strcmp(token, "Y") == 0 ||
+			strcmp(token, "y") == 0)
+			(*vlan_table)[i++] = RTE_COLOR_YELLOW;
+		else if (strcmp(token, "R") == 0 ||
+			strcmp(token, "r") == 0)
+			(*vlan_table)[i++] = RTE_COLOR_RED;
+		else {
+			free(*vlan_table);
+			return -1;
+		}
+		if (i == MAX_VLAN_TABLE_ENTRIES)
+			break;
+
+		token = strtok_r(str, PARSE_DELIMITER, &str);
+		if (token == NULL) {
+			free(*vlan_table);
+			return -1;
+		}
+	}
+	return 0;
+}
+
 static int
 parse_dscp_table_entries(char *str, enum rte_color **dscp_table)
 {
@@ -124,9 +244,59 @@ parse_dscp_table_entries(char *str, enum rte_color **dscp_table)
 	return 0;
 }
 
+static int
+parse_input_color_method(char *str, uint64_t *input_color_method)
+{
+	char *token;
+
+	token = strtok_r(str, PARSE_DELIMITER, &str);
+	if (token == NULL)
+		return 0;
+
+	if (strcmp(token, "blind") == 0)
+		*input_color_method = RTE_MTR_INPUT_COLOR_METHOD_COLOR_BLIND;
+	else if (strcmp(token, "vlan") == 0)
+		*input_color_method = RTE_MTR_INPUT_COLOR_METHOD_VLAN;
+	else if (strcmp(token, "dscp") == 0)
+		*input_color_method = RTE_MTR_INPUT_COLOR_METHOD_DSCP;
+	else if (strcmp(token, "vlan_dscp") == 0)
+		*input_color_method = RTE_MTR_INPUT_COLOR_METHOD_VLAN_DSCP;
+	else if (strcmp(token, "inner_vlan") == 0)
+		*input_color_method = RTE_MTR_INPUT_COLOR_METHOD_INNER_VLAN;
+	else if (strcmp(token, "inner_dscp") == 0)
+		*input_color_method = RTE_MTR_INPUT_COLOR_METHOD_INNER_DSCP;
+	else if (strcmp(token, "inner_vlan_dscp") == 0)
+		*input_color_method = RTE_MTR_INPUT_COLOR_METHOD_INNER_VLAN_DSCP;
+	else
+		return -1;
+
+	return 0;
+}
+
+static int
+parse_default_input_color_str(char *str, uint64_t *def_inp_color)
+{
+	char *token;
+
+	token = strtok_r(str, PARSE_DELIMITER, &str);
+	if (token == NULL)
+		return 0;
+
+	if ((strcmp(token, "G") == 0) || (strcmp(token, "g") == 0))
+		*def_inp_color = RTE_COLOR_GREEN;
+	else if ((strcmp(token, "Y") == 0) || (strcmp(token, "y") == 0))
+		*def_inp_color = RTE_COLOR_YELLOW;
+	else if ((strcmp(token, "R") == 0) || (strcmp(token, "r") == 0))
+		*def_inp_color = RTE_COLOR_RED;
+	else
+		return -1;
+
+	return 0;
+}
+
 static int
 parse_meter_color_str(char *c_str, uint32_t *use_prev_meter_color,
-	enum rte_color **dscp_table)
+	enum rte_color **vlan_table, enum rte_color **dscp_table)
 {
 	char *token;
 	uint64_t previous_mtr_color = 0;
@@ -147,8 +317,7 @@ parse_meter_color_str(char *c_str, uint32_t *use_prev_meter_color,
 		return 0;
 	}
 
-	/* Parse dscp table entries */
-	ret = parse_dscp_table_entries(c_str, dscp_table);
+	ret = parse_input_color_table_entries(c_str, dscp_table, vlan_table);
 	if (ret != 0)
 		return -1;
 
@@ -192,6 +361,43 @@ parse_multi_token_string(char *t_str, uint16_t *port_id,
 	return 0;
 }
 
+static int
+parse_multi_token_vlan_str(char *t_str, uint16_t *port_id, uint32_t *mtr_id,
+	enum rte_color **vlan_table)
+{
+	uint64_t val;
+	char *token;
+	int ret;
+
+	/* First token: port id */
+	token = strtok_r(t_str, PARSE_DELIMITER, &t_str);
+	if (token ==  NULL)
+		return -1;
+
+	ret = parse_uint(&val, token);
+	if (ret != 0 || val > UINT16_MAX)
+		return -1;
+
+	*port_id = val;
+
+	/* Second token: meter id */
+	token = strtok_r(t_str, PARSE_DELIMITER, &t_str);
+	if (token == NULL)
+		return 0;
+
+	ret = parse_uint(&val, token);
+	if (ret != 0 || val > UINT32_MAX)
+		return -1;
+
+	*mtr_id = val;
+
+	ret = parse_vlan_table_entries(t_str, vlan_table);
+	if (ret != 0)
+		return -1;
+
+	return 0;
+}
+
 /* *** Show Port Meter Capabilities *** */
 struct cmd_show_port_meter_cap_result {
 	cmdline_fixed_string_t show;
@@ -277,6 +483,9 @@ static void cmd_show_port_meter_cap_parsed(void *parsed_result,
 	printf("cap.trtcm_rfc4115_packet_mode_supported %" PRId32 "\n",
 		cap.trtcm_rfc4115_packet_mode_supported);
 	printf("cap.stats_mask %" PRIx64 "\n", cap.stats_mask);
+	printf("cap.methods_mask 0x%" PRIx64 "\n", cap.methods_mask);
+	printf("cap.separate_input_color_table_per_port %" PRId32 "\n",
+		cap.separate_input_color_table_per_port);
 }
 
 cmdline_parse_inst_t cmd_show_port_meter_cap = {
@@ -721,6 +930,8 @@ struct cmd_create_port_meter_result {
 	cmdline_fixed_string_t r_action;
 	uint64_t statistics_mask;
 	uint32_t shared;
+	cmdline_fixed_string_t input_color_method;
+	cmdline_fixed_string_t default_input_color;
 	cmdline_multi_string_t meter_input_color;
 };
 
@@ -763,6 +974,12 @@ cmdline_parse_token_num_t cmd_create_port_meter_statistics_mask =
 cmdline_parse_token_num_t cmd_create_port_meter_shared =
 	TOKEN_NUM_INITIALIZER(struct cmd_create_port_meter_result,
 		shared, RTE_UINT32);
+cmdline_parse_token_string_t cmd_create_port_meter_input_color_method =
+	TOKEN_STRING_INITIALIZER(struct cmd_create_port_meter_result,
+		input_color_method, "blind#vlan#dscp#vlan_dscp#inner_vlan#inner_dscp#inner_vlan_dscp");
+cmdline_parse_token_string_t cmd_create_port_meter_default_input_color =
+	TOKEN_STRING_INITIALIZER(struct cmd_create_port_meter_result,
+		default_input_color, "R#Y#G#r#y#g");
 cmdline_parse_token_string_t cmd_create_port_meter_input_color =
 	TOKEN_STRING_INITIALIZER(struct cmd_create_port_meter_result,
 		meter_input_color, TOKEN_STRING_MULTI);
@@ -778,7 +995,12 @@ static void cmd_create_port_meter_parsed(void *parsed_result,
 	uint32_t shared = res->shared;
 	uint32_t use_prev_meter_color = 0;
 	uint16_t port_id = res->port_id;
+	uint64_t input_color_method = 0;
+	uint64_t def_inp_color = 0;
 	enum rte_color *dscp_table = NULL;
+	enum rte_color *vlan_table = NULL;
+	char *def_color_str = res->default_input_color;
+	char *method_str = res->input_color_method;
 	char *c_str = res->meter_input_color;
 	int ret;
 
@@ -789,16 +1011,48 @@ static void cmd_create_port_meter_parsed(void *parsed_result,
 	memset(&params, 0, sizeof(struct rte_mtr_params));
 	params.meter_profile_id = res->profile_id;
 	params.meter_policy_id = res->policy_id;
+
+	/* Parse meter input color method string params */
+	ret = parse_input_color_method(method_str, &input_color_method);
+	if (ret) {
+		fprintf(stderr,
+			" Meter input color method is invalid\n");
+		return;
+	}
+
+	/* Parse meter default input color string params */
+	ret = parse_default_input_color_str(def_color_str, &def_inp_color);
+	if (ret) {
+		fprintf(stderr,
+			" Meter default input color is invalid\n");
+		return;
+	}
+
 	/* Parse meter input color string params */
-	ret = parse_meter_color_str(c_str, &use_prev_meter_color, &dscp_table);
+	ret = parse_meter_color_str(c_str, &use_prev_meter_color, &vlan_table,
+		&dscp_table);
 	if (ret) {
 		fprintf(stderr,
 			" Meter input color params string parse error\n");
 		return;
 	}
 
+	params.input_color_method = input_color_method;
 	params.use_prev_mtr_color = use_prev_meter_color;
-	params.dscp_table = dscp_table;
+
+	if (input_color_method & RTE_MTR_INPUT_COLOR_METHOD_VLAN ||
+	    input_color_method & RTE_MTR_INPUT_COLOR_METHOD_INNER_VLAN)
+		params.vlan_table = vlan_table;
+	else if (input_color_method & RTE_MTR_INPUT_COLOR_METHOD_DSCP ||
+		 input_color_method & RTE_MTR_INPUT_COLOR_METHOD_INNER_DSCP)
+		params.dscp_table = dscp_table;
+	else if (input_color_method & RTE_MTR_INPUT_COLOR_METHOD_VLAN_DSCP ||
+		 input_color_method & RTE_MTR_INPUT_COLOR_METHOD_INNER_VLAN_DSCP) {
+		params.vlan_table = vlan_table;
+		params.dscp_table = dscp_table;
+	}
+
+	params.default_input_color = def_inp_color;
 
 	if (strcmp(res->meter_enable, "yes") == 0)
 		params.meter_enable = 1;
@@ -817,9 +1071,12 @@ static void cmd_create_port_meter_parsed(void *parsed_result,
 cmdline_parse_inst_t cmd_create_port_meter = {
 	.f = cmd_create_port_meter_parsed,
 	.data = NULL,
-	.help_str = "create port meter <port_id> <mtr_id> <profile_id> <meter_enable>(yes|no) "
-		"<stats_mask> <shared> <use_pre_meter_color> "
-		"[<dscp_tbl_entry0> <dscp_tbl_entry1> ...<dscp_tbl_entry63>]",
+	.help_str = "create port meter <port_id> <mtr_id> <profile_id> <policy_id> "
+		"<meter_enable>(yes|no) <stats_mask> <shared> "
+		"<input_color_method>(blind|vlan|dscp|vlan_dscp|inner_vlan|inner_dscp|inner_vlan_dscp) "
+		"<default_input_color>(g|y|r) <use_pre_meter_color> "
+		"[<dscp_tbl_entry0> <dscp_tbl_entry1> ... <dscp_tbl_entry63>]"
+		"[<vlan_tbl_entry0> <vlan_tbl_entry1> ... <vlan_tbl_entry16>]",
 	.tokens = {
 		(void *)&cmd_create_port_meter_create,
 		(void *)&cmd_create_port_meter_port,
@@ -831,6 +1088,8 @@ cmdline_parse_inst_t cmd_create_port_meter = {
 		(void *)&cmd_create_port_meter_meter_enable,
 		(void *)&cmd_create_port_meter_statistics_mask,
 		(void *)&cmd_create_port_meter_shared,
+		(void *)&cmd_create_port_meter_input_color_method,
+		(void *)&cmd_create_port_meter_default_input_color,
 		(void *)&cmd_create_port_meter_input_color,
 		NULL,
 	},
@@ -1233,6 +1492,79 @@ cmdline_parse_inst_t cmd_set_port_meter_dscp_table = {
 	},
 };
 
+/* *** Set Port Meter VLAN Table *** */
+struct cmd_set_port_meter_vlan_table_result {
+	cmdline_fixed_string_t set;
+	cmdline_fixed_string_t port;
+	cmdline_fixed_string_t meter;
+	cmdline_fixed_string_t vlan_table;
+	cmdline_multi_string_t token_string;
+};
+
+cmdline_parse_token_string_t cmd_set_port_meter_vlan_table_set =
+	TOKEN_STRING_INITIALIZER(
+		struct cmd_set_port_meter_vlan_table_result, set, "set");
+cmdline_parse_token_string_t cmd_set_port_meter_vlan_table_port =
+	TOKEN_STRING_INITIALIZER(
+		struct cmd_set_port_meter_vlan_table_result, port, "port");
+cmdline_parse_token_string_t cmd_set_port_meter_vlan_table_meter =
+	TOKEN_STRING_INITIALIZER(
+		struct cmd_set_port_meter_vlan_table_result, meter, "meter");
+cmdline_parse_token_string_t cmd_set_port_meter_vlan_table_vlan_table =
+	TOKEN_STRING_INITIALIZER(
+		struct cmd_set_port_meter_vlan_table_result,
+		vlan_table, "vlan table");
+cmdline_parse_token_string_t cmd_set_port_meter_vlan_table_token_string =
+	TOKEN_STRING_INITIALIZER(struct cmd_set_port_meter_vlan_table_result,
+		token_string, TOKEN_STRING_MULTI);
+
+static void cmd_set_port_meter_vlan_table_parsed(void *parsed_result,
+	__rte_unused struct cmdline *cl,
+	__rte_unused void *data)
+{
+	struct cmd_set_port_meter_vlan_table_result *res = parsed_result;
+	struct rte_mtr_error error;
+	enum rte_color *vlan_table = NULL;
+	char *t_str = res->token_string;
+	uint32_t mtr_id = 0;
+	uint16_t port_id;
+	int ret;
+
+	/* Parse string */
+	ret = parse_multi_token_vlan_str(t_str, &port_id, &mtr_id, &vlan_table);
+	if (ret) {
+		fprintf(stderr, " Multi token string parse error\n");
+		return;
+	}
+
+	if (port_id_is_invalid(port_id, ENABLED_WARN))
+		goto free_table;
+
+	/* Update Meter VLAN Table*/
+	ret = rte_mtr_meter_vlan_table_update(port_id, mtr_id,
+		vlan_table, &error);
+	if (ret != 0)
+		print_err_msg(&error);
+
+free_table:
+	free(vlan_table);
+}
+
+cmdline_parse_inst_t cmd_set_port_meter_vlan_table = {
+	.f = cmd_set_port_meter_vlan_table_parsed,
+	.data = NULL,
+	.help_str = "set port meter vlan table <port_id> <mtr_id> "
+		"[<vlan_tbl_entry0> <vlan_tbl_entry1> ... <vlan_tbl_entry15>]",
+	.tokens = {
+		(void *)&cmd_set_port_meter_vlan_table_set,
+		(void *)&cmd_set_port_meter_vlan_table_port,
+		(void *)&cmd_set_port_meter_vlan_table_meter,
+		(void *)&cmd_set_port_meter_vlan_table_vlan_table,
+		(void *)&cmd_set_port_meter_vlan_table_token_string,
+		NULL,
+	},
+};
+
 /* *** Set Port Meter Stats Mask *** */
 struct cmd_set_port_meter_stats_mask_result {
 	cmdline_fixed_string_t set;
diff --git a/app/test-pmd/cmdline_mtr.h b/app/test-pmd/cmdline_mtr.h
index 2415fc16c3..e11cd6a23b 100644
--- a/app/test-pmd/cmdline_mtr.h
+++ b/app/test-pmd/cmdline_mtr.h
@@ -19,6 +19,7 @@ extern cmdline_parse_inst_t cmd_del_port_meter;
 extern cmdline_parse_inst_t cmd_del_port_meter_policy;
 extern cmdline_parse_inst_t cmd_set_port_meter_profile;
 extern cmdline_parse_inst_t cmd_set_port_meter_dscp_table;
+extern cmdline_parse_inst_t cmd_set_port_meter_vlan_table;
 extern cmdline_parse_inst_t cmd_set_port_meter_stats_mask;
 extern cmdline_parse_inst_t cmd_show_port_meter_stats;
 void print_mtr_err_msg(struct rte_mtr_error *error);