diff --git a/app/test-pmd/cmdline.c b/app/test-pmd/cmdline.c
index 17778c2275..e496fa1d14 100644
--- a/app/test-pmd/cmdline.c
+++ b/app/test-pmd/cmdline.c
@@ -554,29 +554,6 @@ static void cmd_help_long_parsed(void *parsed_result,
 			"   Flush (default) or don't flush RX streams before"
 			" forwarding. Mainly used with PCAP drivers.\n\n"
 
-			"set bypass mode (normal|bypass|isolate) (port_id)\n"
-			"   Set the bypass mode for the lowest port on bypass enabled"
-			" NIC.\n\n"
-
-			"set bypass event (timeout|os_on|os_off|power_on|power_off) "
-			"mode (normal|bypass|isolate) (port_id)\n"
-			"   Set the event required to initiate specified bypass mode for"
-			" the lowest port on a bypass enabled NIC where:\n"
-			"       timeout   = enable bypass after watchdog timeout.\n"
-			"       os_on     = enable bypass when OS/board is powered on.\n"
-			"       os_off    = enable bypass when OS/board is powered off.\n"
-			"       power_on  = enable bypass when power supply is turned on.\n"
-			"       power_off = enable bypass when power supply is turned off."
-			"\n\n"
-
-			"set bypass timeout (0|1.5|2|3|4|8|16|32)\n"
-			"   Set the bypass watchdog timeout to 'n' seconds"
-			" where 0 = instant.\n\n"
-
-			"show bypass config (port_id)\n"
-			"   Show the bypass configuration for a bypass enabled NIC"
-			" using the lowest port on the NIC.\n\n"
-
 			"set link-up port (port_id)\n"
 			"	Set link up for a port.\n\n"
 
@@ -5446,347 +5423,6 @@ static cmdline_parse_inst_t cmd_set_link_check = {
 	},
 };
 
-/* *** SET NIC BYPASS MODE *** */
-struct cmd_set_bypass_mode_result {
-	cmdline_fixed_string_t set;
-	cmdline_fixed_string_t bypass;
-	cmdline_fixed_string_t mode;
-	cmdline_fixed_string_t value;
-	portid_t port_id;
-};
-
-static void
-cmd_set_bypass_mode_parsed(void *parsed_result,
-		__rte_unused struct cmdline *cl,
-		__rte_unused void *data)
-{
-	struct cmd_set_bypass_mode_result *res = parsed_result;
-	portid_t port_id = res->port_id;
-	int32_t rc = -EINVAL;
-
-#if defined RTE_NET_IXGBE && defined RTE_LIBRTE_IXGBE_BYPASS
-	uint32_t bypass_mode = RTE_PMD_IXGBE_BYPASS_MODE_NORMAL;
-
-	if (!strcmp(res->value, "bypass"))
-		bypass_mode = RTE_PMD_IXGBE_BYPASS_MODE_BYPASS;
-	else if (!strcmp(res->value, "isolate"))
-		bypass_mode = RTE_PMD_IXGBE_BYPASS_MODE_ISOLATE;
-	else
-		bypass_mode = RTE_PMD_IXGBE_BYPASS_MODE_NORMAL;
-
-	/* Set the bypass mode for the relevant port. */
-	rc = rte_pmd_ixgbe_bypass_state_set(port_id, &bypass_mode);
-#endif
-	if (rc != 0)
-		fprintf(stderr, "\t Failed to set bypass mode for port = %d.\n",
-			port_id);
-}
-
-static cmdline_parse_token_string_t cmd_setbypass_mode_set =
-	TOKEN_STRING_INITIALIZER(struct cmd_set_bypass_mode_result,
-			set, "set");
-static cmdline_parse_token_string_t cmd_setbypass_mode_bypass =
-	TOKEN_STRING_INITIALIZER(struct cmd_set_bypass_mode_result,
-			bypass, "bypass");
-static cmdline_parse_token_string_t cmd_setbypass_mode_mode =
-	TOKEN_STRING_INITIALIZER(struct cmd_set_bypass_mode_result,
-			mode, "mode");
-static cmdline_parse_token_string_t cmd_setbypass_mode_value =
-	TOKEN_STRING_INITIALIZER(struct cmd_set_bypass_mode_result,
-			value, "normal#bypass#isolate");
-static cmdline_parse_token_num_t cmd_setbypass_mode_port =
-	TOKEN_NUM_INITIALIZER(struct cmd_set_bypass_mode_result,
-				port_id, RTE_UINT16);
-
-static cmdline_parse_inst_t cmd_set_bypass_mode = {
-	.f = cmd_set_bypass_mode_parsed,
-	.help_str = "set bypass mode normal|bypass|isolate <port_id>: "
-	            "Set the NIC bypass mode for port_id",
-	.data = NULL,
-	.tokens = {
-		(void *)&cmd_setbypass_mode_set,
-		(void *)&cmd_setbypass_mode_bypass,
-		(void *)&cmd_setbypass_mode_mode,
-		(void *)&cmd_setbypass_mode_value,
-		(void *)&cmd_setbypass_mode_port,
-		NULL,
-	},
-};
-
-/* *** SET NIC BYPASS EVENT *** */
-struct cmd_set_bypass_event_result {
-	cmdline_fixed_string_t set;
-	cmdline_fixed_string_t bypass;
-	cmdline_fixed_string_t event;
-	cmdline_fixed_string_t event_value;
-	cmdline_fixed_string_t mode;
-	cmdline_fixed_string_t mode_value;
-	portid_t port_id;
-};
-
-static void
-cmd_set_bypass_event_parsed(void *parsed_result,
-		__rte_unused struct cmdline *cl,
-		__rte_unused void *data)
-{
-	int32_t rc = -EINVAL;
-	struct cmd_set_bypass_event_result *res = parsed_result;
-	portid_t port_id = res->port_id;
-
-#if defined RTE_NET_IXGBE && defined RTE_LIBRTE_IXGBE_BYPASS
-	uint32_t bypass_event = RTE_PMD_IXGBE_BYPASS_EVENT_NONE;
-	uint32_t bypass_mode = RTE_PMD_IXGBE_BYPASS_MODE_NORMAL;
-
-	if (!strcmp(res->event_value, "timeout"))
-		bypass_event = RTE_PMD_IXGBE_BYPASS_EVENT_TIMEOUT;
-	else if (!strcmp(res->event_value, "os_on"))
-		bypass_event = RTE_PMD_IXGBE_BYPASS_EVENT_OS_ON;
-	else if (!strcmp(res->event_value, "os_off"))
-		bypass_event = RTE_PMD_IXGBE_BYPASS_EVENT_OS_OFF;
-	else if (!strcmp(res->event_value, "power_on"))
-		bypass_event = RTE_PMD_IXGBE_BYPASS_EVENT_POWER_ON;
-	else if (!strcmp(res->event_value, "power_off"))
-		bypass_event = RTE_PMD_IXGBE_BYPASS_EVENT_POWER_OFF;
-	else
-		bypass_event = RTE_PMD_IXGBE_BYPASS_EVENT_NONE;
-
-	if (!strcmp(res->mode_value, "bypass"))
-		bypass_mode = RTE_PMD_IXGBE_BYPASS_MODE_BYPASS;
-	else if (!strcmp(res->mode_value, "isolate"))
-		bypass_mode = RTE_PMD_IXGBE_BYPASS_MODE_ISOLATE;
-	else
-		bypass_mode = RTE_PMD_IXGBE_BYPASS_MODE_NORMAL;
-
-	/* Set the watchdog timeout. */
-	if (bypass_event == RTE_PMD_IXGBE_BYPASS_EVENT_TIMEOUT) {
-
-		rc = -EINVAL;
-		if (RTE_PMD_IXGBE_BYPASS_TMT_VALID(bypass_timeout)) {
-			rc = rte_pmd_ixgbe_bypass_wd_timeout_store(port_id,
-							   bypass_timeout);
-		}
-		if (rc != 0) {
-			fprintf(stderr,
-				"Failed to set timeout value %u for port %d, errto code: %d.\n",
-				bypass_timeout, port_id, rc);
-		}
-	}
-
-	/* Set the bypass event to transition to bypass mode. */
-	rc = rte_pmd_ixgbe_bypass_event_store(port_id, bypass_event,
-					      bypass_mode);
-#endif
-
-	if (rc != 0)
-		fprintf(stderr, "\t Failed to set bypass event for port = %d.\n",
-			port_id);
-}
-
-static cmdline_parse_token_string_t cmd_setbypass_event_set =
-	TOKEN_STRING_INITIALIZER(struct cmd_set_bypass_event_result,
-			set, "set");
-static cmdline_parse_token_string_t cmd_setbypass_event_bypass =
-	TOKEN_STRING_INITIALIZER(struct cmd_set_bypass_event_result,
-			bypass, "bypass");
-static cmdline_parse_token_string_t cmd_setbypass_event_event =
-	TOKEN_STRING_INITIALIZER(struct cmd_set_bypass_event_result,
-			event, "event");
-static cmdline_parse_token_string_t cmd_setbypass_event_event_value =
-	TOKEN_STRING_INITIALIZER(struct cmd_set_bypass_event_result,
-			event_value, "none#timeout#os_off#os_on#power_on#power_off");
-static cmdline_parse_token_string_t cmd_setbypass_event_mode =
-	TOKEN_STRING_INITIALIZER(struct cmd_set_bypass_event_result,
-			mode, "mode");
-static cmdline_parse_token_string_t cmd_setbypass_event_mode_value =
-	TOKEN_STRING_INITIALIZER(struct cmd_set_bypass_event_result,
-			mode_value, "normal#bypass#isolate");
-static cmdline_parse_token_num_t cmd_setbypass_event_port =
-	TOKEN_NUM_INITIALIZER(struct cmd_set_bypass_event_result,
-				port_id, RTE_UINT16);
-
-static cmdline_parse_inst_t cmd_set_bypass_event = {
-	.f = cmd_set_bypass_event_parsed,
-	.help_str = "set bypass event none|timeout|os_on|os_off|power_on|"
-		"power_off mode normal|bypass|isolate <port_id>: "
-		"Set the NIC bypass event mode for port_id",
-	.data = NULL,
-	.tokens = {
-		(void *)&cmd_setbypass_event_set,
-		(void *)&cmd_setbypass_event_bypass,
-		(void *)&cmd_setbypass_event_event,
-		(void *)&cmd_setbypass_event_event_value,
-		(void *)&cmd_setbypass_event_mode,
-		(void *)&cmd_setbypass_event_mode_value,
-		(void *)&cmd_setbypass_event_port,
-		NULL,
-	},
-};
-
-
-/* *** SET NIC BYPASS TIMEOUT *** */
-struct cmd_set_bypass_timeout_result {
-	cmdline_fixed_string_t set;
-	cmdline_fixed_string_t bypass;
-	cmdline_fixed_string_t timeout;
-	cmdline_fixed_string_t value;
-};
-
-static void
-cmd_set_bypass_timeout_parsed(void *parsed_result,
-		__rte_unused struct cmdline *cl,
-		__rte_unused void *data)
-{
-	__rte_unused struct cmd_set_bypass_timeout_result *res = parsed_result;
-
-#if defined RTE_NET_IXGBE && defined RTE_LIBRTE_IXGBE_BYPASS
-	if (!strcmp(res->value, "1.5"))
-		bypass_timeout = RTE_PMD_IXGBE_BYPASS_TMT_1_5_SEC;
-	else if (!strcmp(res->value, "2"))
-		bypass_timeout = RTE_PMD_IXGBE_BYPASS_TMT_2_SEC;
-	else if (!strcmp(res->value, "3"))
-		bypass_timeout = RTE_PMD_IXGBE_BYPASS_TMT_3_SEC;
-	else if (!strcmp(res->value, "4"))
-		bypass_timeout = RTE_PMD_IXGBE_BYPASS_TMT_4_SEC;
-	else if (!strcmp(res->value, "8"))
-		bypass_timeout = RTE_PMD_IXGBE_BYPASS_TMT_8_SEC;
-	else if (!strcmp(res->value, "16"))
-		bypass_timeout = RTE_PMD_IXGBE_BYPASS_TMT_16_SEC;
-	else if (!strcmp(res->value, "32"))
-		bypass_timeout = RTE_PMD_IXGBE_BYPASS_TMT_32_SEC;
-	else
-		bypass_timeout = RTE_PMD_IXGBE_BYPASS_TMT_OFF;
-#endif
-}
-
-static cmdline_parse_token_string_t cmd_setbypass_timeout_set =
-	TOKEN_STRING_INITIALIZER(struct cmd_set_bypass_timeout_result,
-			set, "set");
-static cmdline_parse_token_string_t cmd_setbypass_timeout_bypass =
-	TOKEN_STRING_INITIALIZER(struct cmd_set_bypass_timeout_result,
-			bypass, "bypass");
-static cmdline_parse_token_string_t cmd_setbypass_timeout_timeout =
-	TOKEN_STRING_INITIALIZER(struct cmd_set_bypass_timeout_result,
-			timeout, "timeout");
-static cmdline_parse_token_string_t cmd_setbypass_timeout_value =
-	TOKEN_STRING_INITIALIZER(struct cmd_set_bypass_timeout_result,
-			value, "0#1.5#2#3#4#8#16#32");
-
-static cmdline_parse_inst_t cmd_set_bypass_timeout = {
-	.f = cmd_set_bypass_timeout_parsed,
-	.help_str = "set bypass timeout 0|1.5|2|3|4|8|16|32: "
-		"Set the NIC bypass watchdog timeout in seconds",
-	.data = NULL,
-	.tokens = {
-		(void *)&cmd_setbypass_timeout_set,
-		(void *)&cmd_setbypass_timeout_bypass,
-		(void *)&cmd_setbypass_timeout_timeout,
-		(void *)&cmd_setbypass_timeout_value,
-		NULL,
-	},
-};
-
-/* *** SHOW NIC BYPASS MODE *** */
-struct cmd_show_bypass_config_result {
-	cmdline_fixed_string_t show;
-	cmdline_fixed_string_t bypass;
-	cmdline_fixed_string_t config;
-	portid_t port_id;
-};
-
-static void
-cmd_show_bypass_config_parsed(void *parsed_result,
-		__rte_unused struct cmdline *cl,
-		__rte_unused void *data)
-{
-	struct cmd_show_bypass_config_result *res = parsed_result;
-	portid_t port_id = res->port_id;
-	int rc = -EINVAL;
-#if defined RTE_NET_IXGBE && defined RTE_LIBRTE_IXGBE_BYPASS
-	uint32_t event_mode;
-	uint32_t bypass_mode;
-	uint32_t timeout = bypass_timeout;
-	unsigned int i;
-
-	static const char * const timeouts[RTE_PMD_IXGBE_BYPASS_TMT_NUM] =
-		{"off", "1.5", "2", "3", "4", "8", "16", "32"};
-	static const char * const modes[RTE_PMD_IXGBE_BYPASS_MODE_NUM] =
-		{"UNKNOWN", "normal", "bypass", "isolate"};
-	static const char * const events[RTE_PMD_IXGBE_BYPASS_EVENT_NUM] = {
-		"NONE",
-		"OS/board on",
-		"power supply on",
-		"OS/board off",
-		"power supply off",
-		"timeout"};
-
-	/* Display the bypass mode.*/
-	if (rte_pmd_ixgbe_bypass_state_show(port_id, &bypass_mode) != 0) {
-		fprintf(stderr, "\tFailed to get bypass mode for port = %d\n",
-			port_id);
-		return;
-	}
-	else {
-		if (!RTE_PMD_IXGBE_BYPASS_MODE_VALID(bypass_mode))
-			bypass_mode = RTE_PMD_IXGBE_BYPASS_MODE_NONE;
-
-		printf("\tbypass mode    = %s\n",  modes[bypass_mode]);
-	}
-
-	/* Display the bypass timeout.*/
-	if (!RTE_PMD_IXGBE_BYPASS_TMT_VALID(timeout))
-		timeout = RTE_PMD_IXGBE_BYPASS_TMT_OFF;
-
-	printf("\tbypass timeout = %s\n", timeouts[timeout]);
-
-	/* Display the bypass events and associated modes. */
-	for (i = RTE_PMD_IXGBE_BYPASS_EVENT_START; i < RTE_DIM(events); i++) {
-
-		if (rte_pmd_ixgbe_bypass_event_show(port_id, i, &event_mode)) {
-			fprintf(stderr,
-				"\tFailed to get bypass mode for event = %s\n",
-				events[i]);
-		} else {
-			if (!RTE_PMD_IXGBE_BYPASS_MODE_VALID(event_mode))
-				event_mode = RTE_PMD_IXGBE_BYPASS_MODE_NONE;
-
-			printf("\tbypass event: %-16s = %s\n", events[i],
-				modes[event_mode]);
-		}
-	}
-#endif
-	if (rc != 0)
-		fprintf(stderr,
-			"\tFailed to get bypass configuration for port = %d\n",
-		       port_id);
-}
-
-static cmdline_parse_token_string_t cmd_showbypass_config_show =
-	TOKEN_STRING_INITIALIZER(struct cmd_show_bypass_config_result,
-			show, "show");
-static cmdline_parse_token_string_t cmd_showbypass_config_bypass =
-	TOKEN_STRING_INITIALIZER(struct cmd_show_bypass_config_result,
-			bypass, "bypass");
-static cmdline_parse_token_string_t cmd_showbypass_config_config =
-	TOKEN_STRING_INITIALIZER(struct cmd_show_bypass_config_result,
-			config, "config");
-static cmdline_parse_token_num_t cmd_showbypass_config_port =
-	TOKEN_NUM_INITIALIZER(struct cmd_show_bypass_config_result,
-				port_id, RTE_UINT16);
-
-static cmdline_parse_inst_t cmd_show_bypass_config = {
-	.f = cmd_show_bypass_config_parsed,
-	.help_str = "show bypass config <port_id>: "
-	            "Show the NIC bypass config for port_id",
-	.data = NULL,
-	.tokens = {
-		(void *)&cmd_showbypass_config_show,
-		(void *)&cmd_showbypass_config_bypass,
-		(void *)&cmd_showbypass_config_config,
-		(void *)&cmd_showbypass_config_port,
-		NULL,
-	},
-};
-
 /* *** SET FORWARDING MODE *** */
 struct cmd_set_fwd_mode_result {
 	cmdline_fixed_string_t set;
@@ -14153,10 +13789,6 @@ static cmdline_parse_ctx_t builtin_ctx[] = {
 	(cmdline_parse_inst_t *)&cmd_set_allmulti_mode_all,
 	(cmdline_parse_inst_t *)&cmd_set_flush_rx,
 	(cmdline_parse_inst_t *)&cmd_set_link_check,
-	(cmdline_parse_inst_t *)&cmd_set_bypass_mode,
-	(cmdline_parse_inst_t *)&cmd_set_bypass_event,
-	(cmdline_parse_inst_t *)&cmd_set_bypass_timeout,
-	(cmdline_parse_inst_t *)&cmd_show_bypass_config,
 	(cmdline_parse_inst_t *)&cmd_vlan_offload,
 	(cmdline_parse_inst_t *)&cmd_vlan_tpid,
 	(cmdline_parse_inst_t *)&cmd_rx_vlan_filter_all,
diff --git a/app/test-pmd/testpmd.c b/app/test-pmd/testpmd.c
index 93ec930b15..caf691a09a 100644
--- a/app/test-pmd/testpmd.c
+++ b/app/test-pmd/testpmd.c
@@ -437,16 +437,6 @@ uint32_t event_print_mask = (UINT32_C(1) << RTE_ETH_EVENT_UNKNOWN) |
  */
 int do_mlockall = 0;
 
-/*
- * NIC bypass mode configuration options.
- */
-
-#if defined RTE_NET_IXGBE && defined RTE_LIBRTE_IXGBE_BYPASS
-/* The NIC bypass watchdog timeout. */
-uint32_t bypass_timeout = RTE_PMD_IXGBE_BYPASS_TMT_OFF;
-#endif
-
-
 #ifdef RTE_LIB_LATENCYSTATS
 
 /*
@@ -3812,10 +3802,6 @@ init_port_config(void)
 		if (ret != 0)
 			return;
 
-#if defined RTE_NET_IXGBE && defined RTE_LIBRTE_IXGBE_BYPASS
-		rte_pmd_ixgbe_bypass_init(pid);
-#endif
-
 		if (lsc_interrupt && (*port->dev_info.dev_flags & RTE_ETH_DEV_INTR_LSC))
 			port->dev_conf.intr_conf.lsc = 1;
 		if (rmv_interrupt && (*port->dev_info.dev_flags & RTE_ETH_DEV_INTR_RMV))
diff --git a/app/test-pmd/testpmd.h b/app/test-pmd/testpmd.h
index 6955c46654..8252daef95 100644
--- a/app/test-pmd/testpmd.h
+++ b/app/test-pmd/testpmd.h
@@ -439,10 +439,6 @@ extern uint8_t hot_plug; /**< enable by "--hot-plug" parameter */
 extern int do_mlockall; /**< set by "--mlockall" or "--no-mlockall" parameter */
 extern uint8_t clear_ptypes; /**< disabled by set ptype cmd */
 
-#ifdef RTE_LIBRTE_IXGBE_BYPASS
-extern uint32_t bypass_timeout; /**< Store the NIC bypass watchdog timeout */
-#endif
-
 /*
  * Store specified sockets on which memory pool to be used by ports
  * is allocated.
diff --git a/doc/guides/testpmd_app_ug/testpmd_funcs.rst b/doc/guides/testpmd_app_ug/testpmd_funcs.rst
index 6394aa42bd..55009507ed 100644
--- a/doc/guides/testpmd_app_ug/testpmd_funcs.rst
+++ b/doc/guides/testpmd_app_ug/testpmd_funcs.rst
@@ -1532,48 +1532,6 @@ Mainly used with PCAP drivers to turn off the default behavior of flushing the f
 
    testpmd> set flush_rx off
 
-set bypass mode
-~~~~~~~~~~~~~~~
-
-Set the bypass mode for the lowest port on bypass enabled NIC::
-
-   testpmd> set bypass mode (normal|bypass|isolate) (port_id)
-
-set bypass event
-~~~~~~~~~~~~~~~~
-
-Set the event required to initiate specified bypass mode for the lowest port on a bypass enabled::
-
-   testpmd> set bypass event (timeout|os_on|os_off|power_on|power_off) \
-            mode (normal|bypass|isolate) (port_id)
-
-Where:
-
-* ``timeout``: Enable bypass after watchdog timeout.
-
-* ``os_on``: Enable bypass when OS/board is powered on.
-
-* ``os_off``: Enable bypass when OS/board is powered off.
-
-* ``power_on``: Enable bypass when power supply is turned on.
-
-* ``power_off``: Enable bypass when power supply is turned off.
-
-
-set bypass timeout
-~~~~~~~~~~~~~~~~~~
-
-Set the bypass watchdog timeout to ``n`` seconds where 0 = instant::
-
-   testpmd> set bypass timeout (0|1.5|2|3|4|8|16|32)
-
-show bypass config
-~~~~~~~~~~~~~~~~~~
-
-Show the bypass configuration for a bypass enabled NIC using the lowest port on the NIC::
-
-   testpmd> show bypass config (port_id)
-
 set link up
 ~~~~~~~~~~~
 